/*#include <stdlib.h>*/
#include <stdio.h>
#include <math.h>

double MM1(double, double, double, double);
double MM2(double, double, double, double);
double MM3(double, double, double, double);
double MM4(double, double, double, double);

double LPDM1(double, double, double, double, double, double, double, double, double);
double LPDM2(double, double, double, double, double, double, double, double, double);
double LPDM3(double, double, double, double, double, double, double, double, double);

/*-----------------------------------------------------------------------------------
					Start of the main program
-------------------------------------------------------------------------------------*/
    
main()
{
double at1,at2,at3,at4, at5,at6, at7, at8,at9,at10,at14,at15,at16,at17,at18,at19,at20,at26,at29,at32;
double at33,at34,at35,at36,at40,at41;
double at42,at48,at51,at52,at53,at54,at55,at59,at60,at61,at67,at68,at72;
double bt14, bt15, bt17, bt19 ,  bt20 ,  bt22 ,  bt24 ,  bt25 , bt27 , bt29 , bt32 , bt33 , bt35; 
double bt37 , bt38 , bt40 , bt42 , bt43 , bt46 , bt49 , bt50 , bt52 , bt54 , bt57 , bt60 , bt63, bt65;
double bt71 , bt73 , bt75 , bt77 , bt81 ,bt83 , bt85 , bt87 , bt101 , bt103 , bt105 , bt107 , bt109;
double bt111 , bt115 , bt117 , bt119 , bt121 , bt123 , bt125 , bt129 , bt131 , bt133 , bt135;    

double Minvf[4][4], Sf[4][4], Sinvf[4][4], HG[4][4];

double mu1,mu2,mu3,mu4, m1,m2,m3,m4, step, bound, a;
double maxLPDM1,minLPDM2,maxLPDM3, currentLPDM1, currentLPDM2, currentLPDM3;


/*Initialization of the variables maxLPDM1,maxLPDM2,maxLPDM3, that keep track of the currently max(low) values per 
LPDM for each 4tuple of mu1, ..., mu4.*/
	maxLPDM1=-1000000000000000;
	minLPDM2=10000000000000000;
	maxLPDM3=-1000000000000000;
	
/*Determination of the step per mu1, ..., mu4 such that the space (0.00000001, 1)^4 with mu1+...+mu4=1 was swept.*/	
	step=1/1000.0;

/*We used 3 while loops to perform the sweeping.*/
	bound= 0.00000001;
	mu1= bound;
	while((mu1<=1-bound) && (mu1>=bound))
		{
		mu2=bound;
		while((mu2<=1-mu1) && (mu2>=bound) )
			{
			mu3=bound;
			while( (mu3<=1-mu1-mu2) && (mu3>=bound))
				{
				mu4= 1-mu1-mu2-mu3;
				if ((mu4>=bound) && (mu4 <=1))
				{
/*------------------------------------------------------------------------------------------
          HERE WE COMPUTE THE 4TUPLE m1, ..., m4  FOR THE GIVEN 4TUPLE mu1, ..., mu4
--------------------------------------------------------------------------------------------*/
						m1= MM1(mu1, mu2,  mu3, mu4);
						m2= MM2(mu1, mu2,  mu3, mu4);
						m3= MM3(mu1, mu2,  mu3, mu4);
						m4= MM4(mu1, mu2,  mu3, mu4);
/*------------------------------------------------------------------------------------------
          HERE WE COMPUTE THE INVERSE MATRIX Minvf FOR THE DETERMINED 4TUPLE m1, ..., m4
		  BY THE 4TUPLE mu1, ..., mu4.
--------------------------------------------------------------------------------------------*/
						Minvf[0][0] = 1/m1/2.0;      
						Minvf[0][1] = 0.0;
						Minvf[0][2] = 0.0;
						Minvf[0][3] = 0.0;
						Minvf[1][0] = 0.0;
						Minvf[1][1] = 1/m2/2.0;
						Minvf[1][2] = 0.0;
						Minvf[1][3] = 0.0;
						Minvf[2][0] = 0.0;
						Minvf[2][1] = 0.0;
						Minvf[2][2] = 1/m3/2.0;
						Minvf[2][3] = 0.0;
						Minvf[3][0] = 0.0;
						Minvf[3][1] = 0.0;
						Minvf[3][2] = 0.0;
						Minvf[3][3] = 1/m4/2.0;
/*-----------------------------------------------------------------------------
          HERE WE COMPUTE THE NUMERIC VALUES OF THE HESSIAN Sf OF FUNCTION    
		  FOR THE GIVEN mu1, ..., mu4
-----------------------------------------------------------------------------*/
						at1 = mu1+mu2+mu3+mu4;      
						at2 = at1*at1;
						at3 = at2*at1;
						at4 = mu1+mu4;
						at5 = at4*at4;
						at6 = at5*at4;
						at7 = mu1+mu2;
						at8 = at7*at7;
						at9 = at8*at7;
						at10 = mu1*mu1;
						at14 = at2*at2;
						at15 = 5.0*at14;
						at16 = at5*at5;
						at17 = 5.0*at16;
						at18 = at8*at8;
						at19 = 5.0*at18;
						at20 = at10*at10;
						at26 = 20.0*(at3-at9)*mu1*mu2;
						at29 = 20.0*at3*mu1*mu3;
						at32 = 20.0*(at3-at6)*mu1*mu4;
						at33 = mu2+mu3;
						at34 = at33*at33;
						at35 = at34*at33;
						at36 = mu2*mu2;
						at40 = at34*at34;
						at41 = 5.0*at40;
						at42 = at36*at36;
						at48 = 20.0*(at3-at35)*mu2*mu3;
						at51 = 20.0*at3*mu2*mu4;
						at52 = mu3+mu4;
						at53 = at52*at52;
						at54 = at53*at52;
						at55 = mu3*mu3;
						at59 = at53*at53;
						at60 = 5.0*at59;
						at61 = at55*at55;
						at67 = 20.0*(at3-at54)*mu3*mu4;
						at68 = mu4*mu4;
						at72 = at68*at68;
						Sf[0][0] = (20.0*(at3-at6-at9+at10*mu1)*mu1+at15-at17-at19+5.0*at20)*mu1;
						Sf[0][1] = at26;
						Sf[0][2] = at29;
						Sf[0][3] = at32;
						Sf[1][0] = at26;
						Sf[1][1] = (20.0*(at3-at9-at35+at36*mu2)*mu2+at15-at19-at41+5.0*at42)*mu2;
						Sf[1][2] = at48;
						Sf[1][3] = at51;
						Sf[2][0] = at29;
						Sf[2][1] = at48;
						Sf[2][2] = (20.0*(at3-at35-at54+at55*mu3)*mu3+at15-at41-at60+5.0*at61)*mu3;
						Sf[2][3] = at67;
						Sf[3][0] = at32;
						Sf[3][1] = at51;
						Sf[3][2] = at67;
						Sf[3][3] = (20.0*(at3-at6-at54+at68*mu4)*mu4+at15-at17-at60+5.0*at72)*mu4;
/*-----------------------------------------------------------------------------------------------------
          HERE WE COMPUTE THE VALUES OF THE INVERSE MATRIX Sinvf OF THE HESSIAN MATRIX Sf 
		  OBTAINED BY THE GIVEN 4TUPLE mu1, ..., mu4.
--------------------------------------------------------------------------------------------------------*/
						bt14 = Sf[0][0]*Sf[1][1];      
						bt15 = Sf[2][2]*Sf[3][3];
						bt17 = Sf[2][3]*Sf[3][2];
						bt19 = Sf[0][0]*Sf[2][1];
						bt20 = Sf[1][2]*Sf[3][3];
						bt22 = Sf[1][3]*Sf[3][2];
						bt24 = Sf[0][0]*Sf[3][1];
						bt25 = Sf[1][2]*Sf[2][3];
						bt27 = Sf[1][3]*Sf[2][2];
						bt29 = Sf[1][0]*Sf[0][1];
						bt32 = Sf[1][0]*Sf[2][1];
						bt33 = Sf[0][2]*Sf[3][3];
						bt35 = Sf[0][3]*Sf[3][2];
						bt37 = Sf[1][0]*Sf[3][1];
						bt38 = Sf[0][2]*Sf[2][3];
						bt40 = Sf[0][3]*Sf[2][2];
						bt42 = bt14*bt15-bt14*bt17-bt19*bt20+bt19*bt22+bt24*bt25-bt24*bt27-bt29*bt15+bt29*bt17+bt32
								*bt33-bt32*bt35-bt37*bt38+bt37*bt40;
						bt43 = Sf[2][0]*Sf[0][1];
						bt46 = Sf[2][0]*Sf[1][1];
						bt49 = Sf[2][0]*Sf[3][1];
						bt50 = Sf[0][2]*Sf[1][3];
						bt52 = Sf[0][3]*Sf[1][2];
						bt54 = Sf[3][0]*Sf[0][1];
						bt57 = Sf[3][0]*Sf[1][1];
						bt60 = Sf[3][0]*Sf[2][1];
						bt63 = bt43*bt20-bt43*bt22-bt46*bt33+bt46*bt35+bt49*bt50-bt49*bt52-bt54*bt25+bt54*bt27+bt57
								*bt38-bt57*bt40-bt60*bt50+bt60*bt52;
						bt65 = 1/(bt42+bt63);
						bt71 = Sf[0][2]*Sf[2][1];
						bt73 = Sf[0][3]*Sf[2][1];
						bt75 = Sf[0][2]*Sf[3][1];
						bt77 = Sf[0][3]*Sf[3][1];
						bt81 = Sf[0][1]*Sf[1][2];
						bt83 = Sf[0][1]*Sf[1][3];
						bt85 = Sf[0][2]*Sf[1][1];
						bt87 = Sf[0][3]*Sf[1][1];
						bt101 = Sf[1][0]*Sf[2][2];
						bt103 = Sf[1][0]*Sf[2][3];
						bt105 = Sf[2][0]*Sf[1][2];
						bt107 = Sf[2][0]*Sf[1][3];
						bt109 = Sf[3][0]*Sf[1][2];
						bt111 = Sf[3][0]*Sf[1][3];
						bt115 = Sf[0][0]*Sf[2][2];
						bt117 = Sf[0][0]*Sf[2][3];
						bt119 = Sf[2][0]*Sf[0][2];
						bt121 = Sf[2][0]*Sf[0][3];
						bt123 = Sf[3][0]*Sf[0][2];
						bt125 = Sf[3][0]*Sf[0][3];
						bt129 = Sf[0][0]*Sf[1][2];
						bt131 = Sf[0][0]*Sf[1][3];
						bt133 = Sf[1][0]*Sf[0][2];
						bt135 = Sf[1][0]*Sf[0][3];
						Sinvf[0][0] = -(-Sf[1][1]*Sf[2][2]*Sf[3][3]+Sf[1][1]*Sf[2][3]*Sf[3][2]+
										Sf[2][1]*Sf[1][2]*Sf[3][3]-Sf[2][1]*Sf[1][3]*Sf[3][2]-Sf[3][1]*Sf[1][2]*Sf[2][3]+
										Sf[3][1]*Sf[1][3]*Sf[2][2])*bt65;
						Sinvf[0][1] = -(Sf[0][1]*Sf[2][2]*Sf[3][3]-Sf[0][1]*Sf[2][3]*Sf[3][2]-
										bt71*Sf[3][3]+bt73*Sf[3][2]+bt75*Sf[2][3]-bt77*Sf[2][2])*bt65;
						Sinvf[0][2] = (bt81*Sf[3][3]-bt83*Sf[3][2]-bt85*Sf[3][3]+bt87*Sf[3][2]+
										bt75*Sf[1][3]-bt77*Sf[1][2])*bt65;
						Sinvf[0][3] = (-bt81*Sf[2][3]+bt83*Sf[2][2]+bt85*Sf[2][3]-bt87*Sf[2][2]-
										bt71*Sf[1][3]+bt73*Sf[1][2])*bt65;
						Sinvf[1][0] = (-bt101*Sf[3][3]+bt103*Sf[3][2]+bt105*Sf[3][3]-bt107*Sf[3][2]-
										bt109*Sf[2][3]+bt111*Sf[2][2])*bt65;
						Sinvf[1][1] = (bt115*Sf[3][3]-bt117*Sf[3][2]-bt119*Sf[3][3]+bt121*Sf[3][2]+
										bt123*Sf[2][3]-bt125*Sf[2][2])*bt65;
						Sinvf[1][2] = -(bt129*Sf[3][3]-bt131*Sf[3][2]-bt133*Sf[3][3]+bt135*Sf[3][2]+
										bt123*Sf[1][3]-bt125*Sf[1][2])*bt65;
						Sinvf[1][3] = (bt129*Sf[2][3]-bt131*Sf[2][2]-bt133*Sf[2][3]+bt135*Sf[2][2]+
										bt119*Sf[1][3]-bt121*Sf[1][2])*bt65;
						Sinvf[2][0] = -(-bt32*Sf[3][3]+bt103*Sf[3][1]+bt46*Sf[3][3]-bt107*Sf[3][1]-
										bt57*Sf[2][3]+bt111*Sf[2][1])*bt65;
						Sinvf[2][1] = -(bt19*Sf[3][3]-bt117*Sf[3][1]-bt43*Sf[3][3]+bt121*Sf[3][1]+
										bt54*Sf[2][3]-bt125*Sf[2][1])*bt65;
						Sinvf[2][2] = (bt14*Sf[3][3]-bt131*Sf[3][1]-bt29*Sf[3][3]+bt135*Sf[3][1]+
										bt54*Sf[1][3]-bt125*Sf[1][1])*bt65;
						Sinvf[2][3] = -(bt14*Sf[2][3]-bt131*Sf[2][1]-bt29*Sf[2][3]+bt135*Sf[2][1]+
										bt43*Sf[1][3]-bt121*Sf[1][1])*bt65;
						Sinvf[3][0] = (-bt32*Sf[3][2]+bt101*Sf[3][1]+bt46*Sf[3][2]-bt105*Sf[3][1]-
										bt57*Sf[2][2]+bt109*Sf[2][1])*bt65;
						Sinvf[3][1] = (bt19*Sf[3][2]-bt115*Sf[3][1]-bt43*Sf[3][2]+bt119*Sf[3][1]+
										bt54*Sf[2][2]-bt123*Sf[2][1])*bt65;
						Sinvf[3][2] = -(bt14*Sf[3][2]-bt129*Sf[3][1]-bt29*Sf[3][2]+bt133*Sf[3][1]+
										bt54*Sf[1][2]-bt123*Sf[1][1])*bt65;
						Sinvf[3][3] = -(-bt14*Sf[2][2]+bt129*Sf[2][1]+bt29*Sf[2][2]-bt133*Sf[2][1]-
										bt43*Sf[1][2]+bt119*Sf[1][1])*bt65;
/*-----------------------------------------------------------------------------------------------------
          HERE WE COMPUTE THE 3x3 MATRIX HG (its 3 LPDMS are crusial) 
		  FROM THE GIVEN MATRICES Minvf, Sinvf
--------------------------------------------------------------------------------------------------------*/
						HG[0][0] = Minvf[0][0]-Sinvf[0][0]-Minvf[3][0]+Sinvf[3][0]-Minvf[0][3]+
									Sinvf[0][3]+Minvf[3][3]-Sinvf[3][3];
						HG[0][1] = Minvf[0][1]-Sinvf[0][1]-Minvf[3][1]+Sinvf[3][1]-Minvf[0][3]+
									Sinvf[0][3]+Minvf[3][3]-Sinvf[3][3];
						HG[0][2] = Minvf[0][2]-Sinvf[0][2]-Minvf[3][2]+Sinvf[3][2]-Minvf[0][3]+
									Sinvf[0][3]+Minvf[3][3]-Sinvf[3][3];
						HG[1][0] = Minvf[1][0]-Sinvf[1][0]-Minvf[3][0]+Sinvf[3][0]-Minvf[1][3]+
									Sinvf[1][3]+Minvf[3][3]-Sinvf[3][3];
						HG[1][1] = Minvf[1][1]-Sinvf[1][1]-Minvf[3][1]+Sinvf[3][1]-Minvf[1][3]+
									Sinvf[1][3]+Minvf[3][3]-Sinvf[3][3];
						HG[1][2] = Minvf[1][2]-Sinvf[1][2]-Minvf[3][2]+Sinvf[3][2]-Minvf[1][3]+
									Sinvf[1][3]+Minvf[3][3]-Sinvf[3][3];
						HG[2][0] = Minvf[2][0]-Sinvf[2][0]-Minvf[3][0]+Sinvf[3][0]-Minvf[2][3]+
									Sinvf[2][3]+Minvf[3][3]-Sinvf[3][3];
						HG[2][1] = Minvf[2][1]-Sinvf[2][1]-Minvf[3][1]+Sinvf[3][1]-Minvf[2][3]+
									Sinvf[2][3]+Minvf[3][3]-Sinvf[3][3];
						HG[2][2] = Minvf[2][2]-Sinvf[2][2]-Minvf[3][2]+Sinvf[3][2]-Minvf[2][3]+
									Sinvf[2][3]+Minvf[3][3]-Sinvf[3][3];
/*----------------------------------------------------------------------------------------------------------------------------
          HERE WE COMPUTE THE NUMERIC VALUES OF THE 3 Leading Prime Determinants (LPDMS) OF MATRIX HG
------------------------------------------------------------------------------------------------------------------------------*/
						currentLPDM1= LPDM1(HG[0][0], HG[0][1], HG[0][2], HG[1][0], HG[1][1], HG[1][2], HG[2][0], HG[2][1], HG[2][2]);
						currentLPDM2= LPDM2(HG[0][0], HG[0][1], HG[0][2], HG[1][0], HG[1][1], HG[1][2], HG[2][0], HG[2][1], HG[2][2]);
						currentLPDM3= LPDM3(HG[0][0], HG[0][1], HG[0][2], HG[1][0], HG[1][1], HG[1][2], HG[2][0], HG[2][1], HG[2][2]);				

																	
/*-----------------------------------------------------------------------------------------------------
          IF THE 3 LPDMS HAVE ***BAD*** ALTERNATING SIGNS THEN IT PRINTS 
		  mu1, ..., mu4, m1, ..., m4, currentLPDM1, currentLPDM2, currentLPDM3.
--------------------------------------------------------------------------------------------------------*/
								if ((currentLPDM1>=0.0) || (currentLPDM2<=0.0) || (currentLPDM3>=0.0))
								{
										printf("mu1 = %20.18f \n" ,mu1);
										printf("mu2 = %20.18f \n" ,mu2);
										printf("mu3 = %20.18f \n" ,mu3);
										printf("mu4 = %20.18f \n" ,mu4);
										
										printf("m1 = %20.18f \n" , m1);
										printf("m2 = %20.18f \n" , m2);
										printf("m3 = %20.18f \n" , m3);
										printf("m4 = %20.18f \n" , m4);	
														
				 						printf("pp1 = %20.18f \n" , currentLPDM1);
										printf("pp2 = %20.18f \n" , currentLPDM2);
										printf("pp3 = %20.18f \n" , currentLPDM3);

										scanf("%f", &a);
								}
										else 
										{
/*-----------------------------------------------------------------------------------------------------
          IF THE 3 LPDMS HAVE ***GOOD*** ALTERNATING SIGNS THEN IT UPDATES  
		                               maxLPDM1, minLPDM2, maxLPDM3.
--------------------------------------------------------------------------------------------------------*/
										if(currentLPDM1 > maxLPDM1 )
										maxLPDM1=currentLPDM1;
												
										if(currentLPDM2 < minLPDM2 )				
												minLPDM2=currentLPDM2;
											
										if(currentLPDM3 > maxLPDM3 )				
												maxLPDM3=currentLPDM3;	
										}

				}				
				mu3=mu3+step;
				}			
			mu2= mu2+step;
			}
		mu1= mu1+step;
		}
/*-----------------------------------------------------------------------------------------------------
          IT PRINTS THE OVERALL maxLPDM1, minLPDM2, maxLPDM3.
--------------------------------------------------------------------------------------------------------*/
printf("Overall max 1st LPDM = %f\t min 2nd LPDM = %f \t max 3rd LPDM = %f\n",maxLPDM1, minLPDM2, maxLPDM3);
}
/*------------------------------------------------------------------------------------------------------*
					END OF THE MAIN PROGRAM
------------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------------*
					START OF USEFUL DEFINITIONS OF FUNCTIONS
------------------------------------------------------------------------------------------------------*/
double LPDM1(x1,x2,x3,y1,y2,y3,z1,z2,z3)
double x1;
double x2;
double x3;
double y1;
double y2;
double y3;
double z1;
double z2;
double z3;
{
  {
    return(x1);
  }
}
/*------------------------------------------------------------------------------------------------------*/
double LPDM2(x1,x2,x3,y1,y2,y3,z1,z2,z3)
double x1;
double x2;
double x3;
double y1;
double y2;
double y3;
double z1;
double z2;
double z3;
{
  {
    return(x1*y2-x2*y1);
  }
}
/*------------------------------------------------------------------------------------------------------*/
double LPDM3(x1,x2,x3,y1,y2,y3,z1,z2,z3)
double x1;
double x2;
double x3;
double y1;
double y2;
double y3;
double z1;
double z2;
double z3;
{
  {
    return(x1*y2*z3-x1*y3*z2-y1*x2*z3+y1*x3*z2+z1*x2*y3-z1*x3*y2);
  }
}
/*------------------------------------------------------------------------------------------------------*/
double MM1(mu1,mu2,mu3,mu4)
double mu1;
double mu2;
double mu3;
double mu4;
{
  double t10;
  double t11;
  double t2;
  double t3;
  double t5;
  double t6;
  double t8;
  double t9;
  {
    t2 = pow(mu1+mu2+mu3+mu4,2.0);
    t3 = t2*t2;
    t5 = pow(mu1+mu4,2.0);
    t6 = t5*t5;
    t8 = pow(mu1+mu2,2.0);
    t9 = t8*t8;
    t10 = mu1*mu1;
    t11 = t10*t10;
    return((5.0*t3-5.0*t6-5.0*t9+5.0*t11)*mu1);
  }
}
/*---------------------------------------------------------------------------------------*/
double MM2(mu1,mu2,mu3,mu4)
double mu1;
double mu2;
double mu3;
double mu4;
{
  double t10;
  double t11;
  double t2;
  double t3;
  double t5;
  double t6;
  double t8;
  double t9;
  {
    t2 = pow(mu1+mu2+mu3+mu4,2.0);
    t3 = t2*t2;
    t5 = pow(mu1+mu2,2.0);
    t6 = t5*t5;
    t8 = pow(mu2+mu3,2.0);
    t9 = t8*t8;
    t10 = mu2*mu2;
    t11 = t10*t10;
    return((5.0*t3-5.0*t6-5.0*t9+5.0*t11)*mu2);
  }
}
/*---------------------------------------------------------------------------------------*/
double MM3(mu1,mu2,mu3,mu4)
double mu1;
double mu2;
double mu3;
double mu4;
{
  double t10;
  double t11;
  double t2;
  double t3;
  double t5;
  double t6;
  double t8;
  double t9;
  {
    t2 = pow(mu1+mu2+mu3+mu4,2.0);
    t3 = t2*t2;
    t5 = pow(mu2+mu3,2.0);
    t6 = t5*t5;
    t8 = pow(mu3+mu4,2.0);
    t9 = t8*t8;
    t10 = mu3*mu3;
    t11 = t10*t10;
    return((5.0*t3-5.0*t6-5.0*t9+5.0*t11)*mu3);
  }
}
/*---------------------------------------------------------------------------------------*/
double MM4(mu1,mu2,mu3,mu4)
double mu1;
double mu2;
double mu3;
double mu4;
{
  double t10;
  double t11;
  double t2;
  double t3;
  double t5;
  double t6;
  double t8;
  double t9;
  {
    t2 = pow(mu1+mu2+mu3+mu4,2.0);
    t3 = t2*t2;
    t5 = pow(mu1+mu4,2.0);
    t6 = t5*t5;
    t8 = pow(mu3+mu4,2.0);
    t9 = t8*t8;
    t10 = mu4*mu4;
    t11 = t10*t10;
    return((5.0*t3-5.0*t6-5.0*t9+5.0*t11)*mu4);
  }
}

/*------------------------------------------------------------------------------------------------------*
					END OF USEFUL DEFINITIONS OF FUNCTIONS
------------------------------------------------------------------------------------------------------*/